﻿using Hotline.Share.Dtos.Article;
using MapsterMapper;
using MediatR;
using XF.Domain.Dependency;
using XF.Domain.Repository;

namespace Hotline.DataSharing.WebPortal
{
    public class BulletinService : IBulletinService, IScopeDependency
    {
        private readonly IMapper _mapper;
        private readonly IMediator _mediator;
        private readonly IRepository<DsBulletin> _dsBulletinRepository;

        public BulletinService(IMapper mapper,
          IMediator mediator,
          IRepository<DsBulletin> dsBulletinRepository)
        {
            _mapper = mapper;
            _mediator = mediator;
            _dsBulletinRepository = dsBulletinRepository;
        }

        /// <summary>
        /// 新增公告数据
        /// </summary>
        /// <param name="a"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public async Task PushBulletin(PublishBulletinDto dto, CancellationToken cancellationToken)
        {
            var data = _mapper.Map<DsBulletin>(dto);
            data.BulletinId = dto.Id;
            data.BulletinTime = dto.ExaminTime;
            await _dsBulletinRepository.AddAsync(data, cancellationToken);
        }
    }
}
